<?php
/**
* @Author: camil
* @Date:    Jan 29, 2011
* $Id$
*
* @Description:
*
**/

// Disclaimer : Under development. No data check done yet. Use at your own risks!

class testXmlParser {
  
  public function __construct() {
  }
  
  public function __desctruct() {
  }
  
  public function parseXmlToArray($data, $name = '') {
    $data = trim($this->parse_multipart_form($data));
    if($name == '')
      return $this->unserialize_xml($data);
    else {
      $array = array();
      $array[$name] = $this->unserialize_xml($data);
      return $array;
    }
  }
  
  /*
   * Multipart form data looks like this :
    --vaNSCaxqVUpon23otGMsyCrvwyFvZbzi3hWCh
    Content-Disposition: form-data; name="data"; filename="1111.xml"

    <?xml version="1.0"?>
    <test>
    <att1>1111</att1>
    <agent>AGENT TEST</agent>
    <action>ACTION TEST</action>
    <gpscoord>123,456,789,012</gpscoord>
    </test>
    
    --vaNSCaxqVUpon23otGMsyCrvwyFvZbzi3hWCh--
   */
  public function parse_multipart_form($data) {
    $separator = $this->parse_multipart_form_separator($data);
    if(strcmp($separator,"") == 0)
      return "";
    $header = $this->parse_multipart_form_header($data, strlen($separator));
    //Strip separator and header
    $data = substr($data,strlen($separator.$header),strlen($data)-strlen($separator.$header));
    //Strip end separator
    $data = substr($data, 0, strlen($data)-(strlen($separator)+2));
    return $data;
    //Cannot use the following piece of code when there is a very very long string between 2 tags!! (too bad)
    //preg_match('/<test>(.*)<\/test>/msU',$data,$matches);
    //return $matches[0];
  }
  
  public function parse_multipart_form_separator($data) {
    $aux1 = strpos($data,"\n",0);
    $sep = substr($data,0,$aux1+1);
    if(strcmp(substr($sep,0,2),"--") == 0)
      return $sep;
    else
      return "";
  }
  
  public function parse_multipart_form_header($data, $offset) {
    $aux1 = strpos($data,"\n",$offset);
    $sep = substr($data,$offset,$aux1-$offset+1);
    return $sep;
  }
  
  /* bool/array unserialize_xml ( string $input [ , callback $callback ] )
   * Unserializes an XML string, returning a multi-dimensional associative array, optionally runs a callback on all non-array data
   * Returns false on all failure
   * Notes:
      * Root XML tags are stripped
      * Due to its recursive nature, unserialize_xml() will also support SimpleXMLElement objects and arrays as input
      * Uses simplexml_load_string() for XML parsing, see SimpleXML documentation for more info
   */
  //This function comes from http://php.net/manual/en/function.simplexml-load-string.php 
  public function unserialize_xml($input, $callback = null, $recurse = false) {
    // Get input, loading an xml string with simplexml if its the top level of recursion
    $data = ((!$recurse) && is_string($input))? simplexml_load_string($input): $input;
    // Convert SimpleXMLElements to array
    if ($data instanceof SimpleXMLElement) $data = (array) $data;
    // Recurse into arrays
    if (is_array($data)) foreach ($data as &$item) $item = $this->unserialize_xml($item, $callback, true);
    // Run callback and return
    return (!is_array($data) && is_callable($callback))? call_user_func($callback, $data): $data;
  }
  
}
